#
# Borland C++ makefile for POV-Ray v. 3.5 
# Hacked by Vahur Krouverk
# vkrouverk@starman.ee
#
.AUTODEPEND


#
# Borland C++ tools
#
IMPLIB  = Implib
BCC32   = Bcc32 +BccW32.cfg 
BCC32I  = Bcc32i +BccW32.cfg 
TLINK32 = TLink32
ILINK32 = Ilink32
TLIB    = TLib
BRC32   = Brc32
TASM32  = Tasm32


#
# PATH macros, adjust, if needed.
#
BORLANDPATH=d:\Borland\bcc55


JPEGLIBSRC=..\..\SOURCE\jpeg-6b
JPGLIBBIN=.\JPGLIB

ZLIBSRC=..\..\SOURCE\ZLIB
ZLIBBIN=.\ZLIB

PNGLIBSRC=..\..\SOURCE\LPNG121
PNGLIBBIN=.\PNGLIB

POVSRC=..\..\SOURCE
POVLIB=.\POVLIB

POVWINSRC=..
POVWINLIB=.\WINLIB

TIFFLIBSRC=..\..\SOURCE\tiff-v3.5.7\libtiff
TIFFLIBBIN=.\TIFFLIB


#define DEBUG to create debug version of program
DEBUG=1

#
# Options
#
IDE_LinkFLAGS32 =  -L$(BORLANDPATH)\LIB
IDE_ResFLAGS32 = -I$(BORLANDPATH)\include

#Global compiler options
#include path 
POVINCLUDE = -I..\;..\..\SOURCE;..\..\SOURCE\ZLIB;..\..\SOURCE\LPNG121;..\..\SOURCE\jpeg-6b;..\..\SOURCE\tiff-v3.5.7\libtiff;$(BORLANDPATH)\INCLUDE

CompilerOpts = -P -DCLASSLIB_DEFS_H -w -g200 $(POVINCLUDE) -w-8061
DebugCompilerOpts = -R -k -y -v
OptimizedCompilerOpts = -ff -OS -Ov -Oi -6
WindowsCompilerOpts = -W -DCOMMONCTRL_VERSION=0x0400 -WM


!if $d(DEBUG)
GlobalCompilerOpts = $(DebugCompilerOpts) $(CompilerOpts)
!else
GlobalCompilerOpts = $(OptimizedCompilerOpts) $(CompilerOpts)
!endif

LibOpts = /P128
ExeLinkerOpts = -Tpe -aa -V4.0 -c -L$(BORLANDPATH)\LIB

ExeCompOpts = $(GlobalCompilerOpts) $(WindowsCompilerOpts) 
LibCompOpts = $(GlobalCompilerOpts)
JpgLibCompOpts = -DWIN32 -D_MBCS -P-


NULL=nul


#
# Dependency List
#
Dep_pvengine = \
   pvengine2.exe

pvengine : BccW32.cfg $(Dep_pvengine)
  @echo Done $(Dep_pvengine) Happy rendering.

init::
    -if not exist "$(JPGLIBBIN)\$(NULL)" mkdir "$(JPGLIBBIN)"
    -if not exist "$(ZLIBBIN)\$(NULL)" mkdir "$(ZLIBBIN)"
    -if not exist "$(PNGLIBBIN)\$(NULL)" mkdir "$(PNGLIBBIN)"
    -if not exist "$(POVLIB)\$(NULL)" mkdir "$(POVLIB)"
    -if not exist "$(POVWINLIB)\$(NULL)" mkdir "$(POVWINLIB)"
    -if not exist "$(TIFFLIBBIN)\$(NULL)" mkdir "$(TIFFLIBBIN)"

  
clean::
     -del "$(JPGLIBBIN)\*.obj"
     -del "$(ZLIBBIN)\*.obj"
     -del "$(PNGLIBBIN)\*.obj"
     -del "$(POVLIB)\*.obj"
     -del "$(POVWINLIB)\*.obj"
     -del "$(POVWINLIB)\*.res"
     -del "$(TIFFLIBBIN)\*.obj"
     -del "*.lib"

Dep_pvenginedexe = \
   $(POVWINLIB)\pvengine.obj\
   $(POVWINLIB)\pvbitmap.obj\
   $(POVWINLIB)\pvtext.obj\
   $(POVWINLIB)\pvmisc.obj\
   $(POVWINLIB)\pvmenu.obj\
   $(POVWINLIB)\pvfiles.obj\
   $(POVWINLIB)\pvdialog.obj\
   $(POVWINLIB)\pvbmp.obj\
   $(POVWINLIB)\pvguiext.obj\
   $(POVWINLIB)\pvedit.obj\
   $(POVWINLIB)\pvengine.res\
   ..\pvengine.def\
   povbcc.lib\
   libpng.lib\
   zlib.lib\
   libjpg.lib\
   libtiff.lib\
   htmlhelp.lib
   #ztimer.lib

pvengine2.exe : $(Dep_pvenginedexe)
  $(ILINK32) @&&|
 /v $(IDE_LinkFLAGS32) $(ExeLinkerOpts) +
$(BORLANDPATH)\LIB\c0w32.obj+
$(POVWINLIB)\pvengine.obj+
$(POVWINLIB)\pvbitmap.obj+
$(POVWINLIB)\pvtext.obj+
$(POVWINLIB)\pvmisc.obj+
$(POVWINLIB)\pvmenu.obj+
$(POVWINLIB)\pvfiles.obj+
$(POVWINLIB)\pvdialog.obj+
$(POVWINLIB)\pvbmp.obj+
$(POVWINLIB)\pvguiext.obj+
$(POVWINLIB)\pvedit.obj
$<,$*
povbcc.lib+
libpng.lib+
zlib.lib+
libjpg.lib+
libtiff.lib+
#ztimer.lib+
$(BORLANDPATH)\LIB\import32.lib+
$(BORLANDPATH)\LIB\cw32mt.lib+
htmlhelp.lib
..\pvengine.def
$(POVWINLIB)\pvengine.res
|

{$(POVWINSRC)}.c{$(POVWINLIB)}.obj:
  $(BCC32) -c @&&|
 $(ExeCompOpts) -o$@ $**
|

htmlhelp.lib:
    implib $@ $(WINDIR)\system32\hhctrl.ocx

$(POVWINLIB)\pvengine.res :  {$(POVWINSRC)}pvengine.rc
  $(BRC32) -R @&&|
 $(IDE_ResFLAGS32) $(ResCompOpts)  -FO$@ $**
|

Dep_povbccdlib = \
$(POVLIB)\atmosph.obj\
$(POVLIB)\bbox.obj\
$(POVLIB)\bcyl.obj\
$(POVLIB)\bezier.obj\
$(POVLIB)\blob.obj\
$(POVLIB)\boxes.obj\
$(POVLIB)\bsphere.obj\
$(POVLIB)\chi2.obj\
$(POVLIB)\colour.obj\
$(POVLIB)\cones.obj\
$(POVLIB)\csg.obj\
$(POVLIB)\discs.obj\
$(POVLIB)\fractal.obj\
$(POVLIB)\hcmplx.obj\
$(POVLIB)\hfield.obj\
$(POVLIB)\iff.obj\
$(POVLIB)\image.obj\
$(POVLIB)\interior.obj\
$(POVLIB)\isosurf.obj\
$(POVLIB)\lathe.obj\
$(POVLIB)\lbuffer.obj\
$(POVLIB)\lightgrp.obj\
$(POVLIB)\lighting.obj\
$(POVLIB)\matrices.obj\
$(POVLIB)\media.obj\
$(POVLIB)\pov_mem.obj\
$(POVLIB)\mesh.obj\
$(POVLIB)\normal.obj\
$(POVLIB)\objects.obj\
$(POVLIB)\octree.obj\
$(POVLIB)\optin.obj\
$(POVLIB)\optout.obj\
$(POVLIB)\parstxtr.obj\
$(POVLIB)\pattern.obj\
$(POVLIB)\pgm.obj\
$(POVLIB)\photons.obj\
$(POVLIB)\planes.obj\
$(POVLIB)\png_pov.obj\
$(POVLIB)\point.obj\
$(POVLIB)\poly.obj\
$(POVLIB)\polygon.obj\
$(POVLIB)\polysolv.obj\
$(POVLIB)\povray.obj\
$(POVLIB)\ppm.obj\
$(POVLIB)\prism.obj\
$(POVLIB)\quadrics.obj\
$(POVLIB)\quatern.obj\
$(POVLIB)\rad_data.obj\
$(POVLIB)\radiosit.obj\
$(POVLIB)\ray.obj\
$(POVLIB)\render.obj\
$(POVLIB)\sor.obj\
$(POVLIB)\spheres.obj\
$(POVLIB)\sphsweep.obj\
$(POVLIB)\splines.obj\
$(POVLIB)\super.obj\
$(POVLIB)\targa.obj\
$(POVLIB)\texture.obj\
$(POVLIB)\torus.obj\
$(POVLIB)\triangle.obj\
$(POVLIB)\truetype.obj\
$(POVLIB)\txttest.obj\
$(POVLIB)\userio.obj\
$(POVLIB)\vbuffer.obj\
$(POVLIB)\vlbuffer.obj\
$(POVLIB)\camera.obj\
$(POVLIB)\express.obj\
$(POVLIB)\parse.obj\
$(POVLIB)\pigment.obj\
$(POVLIB)\tokenize.obj\
$(POVLIB)\warps.obj\
$(POVLIB)\renderio.obj\
$(POVLIB)\benchmark.obj\
$(POVLIB)\file_pov.obj\
$(POVLIB)\povms.obj\
$(POVLIB)\colutils.obj\
$(POVLIB)\fncode.obj\
$(POVLIB)\fnintern.obj\
$(POVLIB)\fnpovfpu.obj\
$(POVLIB)\fnsyntax.obj\
$(POVLIB)\fpmetric.obj\
$(POVLIB)\function.obj\
$(POVLIB)\gif.obj\
$(POVLIB)\gifdecod.obj\
$(POVLIB)\histogra.obj\
$(POVLIB)\jpeg_pov.obj\
$(POVLIB)\parsestr.obj\
$(POVLIB)\pov_util.obj\
$(POVLIB)\povmscpp.obj\
$(POVLIB)\povmsend.obj\
$(POVLIB)\povmsrec.obj\
$(POVLIB)\statspov.obj\
$(POVLIB)\tiff_pov.obj\
$(POVLIB)\userdisp.obj\
$(POVLIB)\hmath.obj


povbcc.lib : $(Dep_povbccdlib)
  $(TLIB) $< $(LibOpts) @&&|
-+$(Dep_povbccdlib: = &^
-+)
|


{$(POVSRC)}.cpp{$(POVLIB)}.obj:
  $(BCC32) -c @&&|
 $(LibCompOpts) -o$@ $**
|



Dep_libpngdlib = \
   $(PNGLIBBIN)\pngwutil.obj\
   $(PNGLIBBIN)\pngwtran.obj\
   $(PNGLIBBIN)\pngwrite.obj\
   $(PNGLIBBIN)\pngwio.obj\
   $(PNGLIBBIN)\pngtrans.obj\
   $(PNGLIBBIN)\pngset.obj\
   $(PNGLIBBIN)\pngrutil.obj\
   $(PNGLIBBIN)\pngrtran.obj\
   $(PNGLIBBIN)\pngrio.obj\
   $(PNGLIBBIN)\pngread.obj\
   $(PNGLIBBIN)\pngpread.obj\
   $(PNGLIBBIN)\pngmem.obj\
   $(PNGLIBBIN)\pngget.obj\
   $(PNGLIBBIN)\pngerror.obj\
   $(PNGLIBBIN)\png.obj

libpng.lib : $(Dep_libpngdlib)
  $(TLIB) $< $(LibOpts) @&&|
+- $(**: = &^
+-)
!
|

{$(PNGLIBSRC)}.c{$(PNGLIBBIN)}.obj:
  $(BCC32) -c @&&|
 $(LibCompOpts) -P- -o$@ $**
|


Dep_zlibdlib = \
   $(ZLIBBIN)\zutil.obj\
   $(ZLIBBIN)\uncompr.obj\
   $(ZLIBBIN)\trees.obj\
   $(ZLIBBIN)\minigzip.obj\
   $(ZLIBBIN)\infutil.obj\
   $(ZLIBBIN)\inftrees.obj\
   $(ZLIBBIN)\inflate.obj\
   $(ZLIBBIN)\inffast.obj\
   $(ZLIBBIN)\infcodes.obj\
   $(ZLIBBIN)\infblock.obj\
   $(ZLIBBIN)\gzio.obj\
   $(ZLIBBIN)\deflate.obj\
   $(ZLIBBIN)\crc32.obj\
   $(ZLIBBIN)\compress.obj\
   $(ZLIBBIN)\adler32.obj

zlib.lib : $(Dep_zlibdlib)
  $(TLIB) $< $(LibOpts) @&&|
+- $(**: = &^
+-)
!
|

#zlib should be compiled as c code!
{$(ZLIBSRC)}.c{$(ZLIBBIN)}.obj:
  $(BCC32) -c @&&|
 $(LibCompOpts) -P- -o$@ $**
|
   



Dep_libjpgdlib = \
$(JPGLIBBIN)\jcapimin.obj\
$(JPGLIBBIN)\jcapistd.obj\
$(JPGLIBBIN)\jctrans.obj\
$(JPGLIBBIN)\jcparam.obj\
$(JPGLIBBIN)\jdatadst.obj\
$(JPGLIBBIN)\jcinit.obj\
$(JPGLIBBIN)\jcmaster.obj\
$(JPGLIBBIN)\jcmarker.obj\
$(JPGLIBBIN)\jcmainct.obj\
$(JPGLIBBIN)\jcprepct.obj\
$(JPGLIBBIN)\jccoefct.obj\ 
$(JPGLIBBIN)\jccolor.obj\
$(JPGLIBBIN)\jcsample.obj\
$(JPGLIBBIN)\jchuff.obj\
$(JPGLIBBIN)\jcphuff.obj\
$(JPGLIBBIN)\jcdctmgr.obj\
$(JPGLIBBIN)\jfdctfst.obj\
$(JPGLIBBIN)\jfdctflt.obj\
$(JPGLIBBIN)\jfdctint.obj\
$(JPGLIBBIN)\jdapimin.obj\
$(JPGLIBBIN)\jdapistd.obj\
$(JPGLIBBIN)\jdtrans.obj\
$(JPGLIBBIN)\jdatasrc.obj\
$(JPGLIBBIN)\jdmaster.obj\
$(JPGLIBBIN)\jdinput.obj\
$(JPGLIBBIN)\jdmarker.obj\
$(JPGLIBBIN)\jdhuff.obj\
$(JPGLIBBIN)\jdphuff.obj\
$(JPGLIBBIN)\jdmainct.obj\
$(JPGLIBBIN)\jdcoefct.obj\
$(JPGLIBBIN)\jdpostct.obj\
$(JPGLIBBIN)\jddctmgr.obj\
$(JPGLIBBIN)\jidctfst.obj\
$(JPGLIBBIN)\jidctflt.obj\
$(JPGLIBBIN)\jidctint.obj\
$(JPGLIBBIN)\jidctred.obj\ 
$(JPGLIBBIN)\jdsample.obj\
$(JPGLIBBIN)\jdcolor.obj\
$(JPGLIBBIN)\jquant1.obj\
$(JPGLIBBIN)\jquant2.obj\
$(JPGLIBBIN)\jdmerge.obj\
$(JPGLIBBIN)\jcomapi.obj\
$(JPGLIBBIN)\jutils.obj\
$(JPGLIBBIN)\jerror.obj\
$(JPGLIBBIN)\jmemmgr.obj\
$(JPGLIBBIN)\jmemansi.obj


libjpg.lib : $(Dep_libjpgdlib)
  $(TLIB) $< $(LibOpts)  @&&|
+- $(**: = &^
+-)
!
|


{$(JPEGLIBSRC)}.c{$(JPGLIBBIN)}.obj:
  $(BCC32) -c @&&|
 $(LibCompOpts) $(JpgLibCompOpts) -o$@ $**
|

Dep_libtiffdlib = \
$(TIFFLIBBIN)\fax3sm_winnt.obj\
$(TIFFLIBBIN)\tif_aux.obj\
$(TIFFLIBBIN)\tif_close.obj\
$(TIFFLIBBIN)\tif_codec.obj\
$(TIFFLIBBIN)\tif_compress.obj\
$(TIFFLIBBIN)\tif_dir.obj\
$(TIFFLIBBIN)\tif_dirinfo.obj\
$(TIFFLIBBIN)\tif_dirread.obj\
$(TIFFLIBBIN)\tif_dirwrite.obj\
$(TIFFLIBBIN)\tif_dumpmode.obj\
$(TIFFLIBBIN)\tif_error.obj\
$(TIFFLIBBIN)\tif_fax3.obj\
$(TIFFLIBBIN)\tif_flush.obj\
$(TIFFLIBBIN)\tif_getimage.obj\
$(TIFFLIBBIN)\tif_jpeg.obj\
$(TIFFLIBBIN)\tif_luv.obj\
$(TIFFLIBBIN)\tif_lzw.obj\
$(TIFFLIBBIN)\tif_next.obj\
$(TIFFLIBBIN)\tif_ojpeg.obj\
$(TIFFLIBBIN)\tif_open.obj\
$(TIFFLIBBIN)\tif_packbits.obj\
$(TIFFLIBBIN)\tif_pixarlog.obj\
$(TIFFLIBBIN)\tif_predict.obj\
$(TIFFLIBBIN)\tif_print.obj\
$(TIFFLIBBIN)\tif_read.obj\
$(TIFFLIBBIN)\tif_strip.obj\
$(TIFFLIBBIN)\tif_swab.obj\
$(TIFFLIBBIN)\tif_thunder.obj\
$(TIFFLIBBIN)\tif_tile.obj\
$(TIFFLIBBIN)\tif_version.obj\
$(TIFFLIBBIN)\tif_warning.obj\
$(TIFFLIBBIN)\tif_win32.obj\
$(TIFFLIBBIN)\tif_write.obj\
$(TIFFLIBBIN)\tif_zip.obj

libtiff.lib : $(Dep_libtiffdlib)
  $(TLIB) $< $(LibOpts) @&&|
+- $(**: = &^
+-)
!
|


{$(TIFFLIBSRC)}.c{$(TIFFLIBBIN)}.obj:
  $(BCC32) -c @&&|
 $(LibCompOpts) -P- -o$@ $**
|


# Compiler configuration file
BccW32.cfg : 
   Copy &&|
-w
-R
-v
-WM-
-vi
-H-
-y
-5
| $@


